
.. index::
   pair: sqlanydb ; SQL Anywhere
   pair: Python ; SQL Anywhere
   pair: Python ; sqlanydb
   pair: softwareheritage ; sqlanydb


.. _sqlanydb:

==================================================================
Module Python **sqlanydb**
==================================================================

.. seealso::

   - https://github.com/sqlanywhere/sqlanydb
   - https://archive.softwareheritage.org/browse/origin/https://github.com/sqlanywhere/sqlanydb/directory/
   - http://infocenter.sybase.com/help/index.jsp?topic=/com.sybase.help.sqlanywhere.12.0.1/dbprogramming/pg-python.html
   - https://hynek.me/articles/django-and-remote-sybase-servers/






Historique
============

.. figure:: sqlanydb_python.png
   :align: center


Requirements
===============

Before installing the sqlanydb interface please make sure the following
components are installed on your system.


* Python 2.4 or greater (including Python 3.x)
* Python ctypes module if missing
* SQL Anywhere 10 or higher


Installation de sqlanydb
=========================

::

    root@74b98b1203eb:~/projects/test_sqlanydb# pipenv install sqlanydb

::

	Traceback (most recent call last):
	  File "/usr/local/bin/pipenv", line 11, in <module>
		sys.exit(cli())
	  File "/usr/local/lib/python3.6/dist-packages/pipenv/vendor/click/core.py", line 722, in __call__
		return self.main(*args, **kwargs)
	  File "/usr/local/lib/python3.6/dist-packages/pipenv/vendor/click/core.py", line 676, in main
		_verify_python3_env()
	  File "/usr/local/lib/python3.6/dist-packages/pipenv/vendor/click/_unicodefun.py", line 118, in _verify_python3_env
		'for mitigation steps.' + extra)
	RuntimeError: Click will abort further execution because Python 3 was configured to use ASCII as encoding for the environment.  Consult http://click.pocoo.org/python3/for mitigation steps.

	This system supports the C.UTF-8 locale which is recommended.
	You might be able to resolve your issue by exporting the
	following environment variables:

		export LC_ALL=C.UTF-8
		export LANG=C.UTF-8

::


	root@74b98b1203eb:~/projects/test_sqlanydb# export LC_ALL=C.UTF-8
	root@74b98b1203eb:~/projects/test_sqlanydb# export LANG=C.UTF-8



tool_sybase.py
=================

.. literalinclude:: python/tool_sybase.py
   :linenos:


test_sybase_connect.py
==========================


.. literalinclude:: python/test_sybase_connect.py
   :linenos:



Lecture de la base "id3semi" (dbgapo/id3semi, gpao/flat)
===========================================================


.. literalinclude:: python/test_read_dbgpao.py
   :linenos:


Lecture des clients
----------------------

::

    pipenv run python test_read_dbgpao.py read_clients


::

	N°374 CLIENTS(CODE_CLIENT='0371', CATEGORIE='C', RAISON_SOCIALE='ANIKLAB LCC', TELEPHONE=None, TELEX=None, FAX=None, SITE_WEB=None, NOM_RUE_SIEGE='Kiyevskoye Shosse, 6, Building 1\r\nBusiness Center Comcity', LOCALITE_SIEGE='MOSCOW', CODE_POSTAL_SIEGE='119620', PAYS_SIEGE='RU', INTERLOCUTEUR_SIEGE=None, TELEPHONE_DIRECT=None, ADRESSE_AR_COMMANDE=None, ADRESSE_LIVRAISON=None, ADRESSE_FACTURATION=None, LANGUE='EN', DEVISE='EUR', CONDITION_PAIEMENT='X1', MODE_TRANSPORT='D1', FRANCHISE_PORT=0.0, FORME_JURIDIQUE=None, CAPITAL=0.0, EFFECTIFS=0.0, RC=None, INTRACOM=None, SIRET=None, BANQUE=None, ETABLISSEMENT=None, GUICHET=None, COMPTE=None, CLE_RIB=None, COMPTE_CLIENT=None, COMMERCIAL='0009', ZONE_GEOGRAPHIQUE='ZZZZ', REMISE_PARTICULIERE=0.0, COMMENTAIRES=None, ESCOMPTE=0.0, PLAFOND_ENCOURS=1000.0, PLAFOND_ENCOURS_EU=1000.0, CLIENT_LITIGIEUX=0, ACTIVITE='ZZZZ', TRANSPORTEUR='ZZZZ', LOCALISATION='E', MODE_CALCUL_TVA='E', NUMERO_FOURNISSEUR=None, HT_OFFRES=0.0, HT_OFFRES_EU=0.0, DATE_DERN_OFFRE=None, NBRE_OFFRES=0, AP_NBRE_OFFRES=0, NBRE_OFFRES_CDES=0, AP_NBRE_OFFRES_CDES=0, ENCOURS_CDES=15.0, ENCOURS_CDES_EU=15.0, CA_AN=0.0, CA_AN_EU=0.0, AP_CA_AN=0.0, AP_CA_AN_EU=0.0, DATE_DERN_CDE='20180504', CA_MOIS1=0.0, CA_MOIS2=0.0, CA_MOIS3=0.0, CA_MOIS4=0.0, CA_MOIS5=0.0, CA_MOIS6=0.0, CA_MOIS7=0.0, CA_MOIS8=0.0, CA_MOIS9=0.0, CA_MOIS10=0.0, CA_MOIS11=0.0, CA_MOIS12=0.0, AP_CA_MOIS1=0.0, AP_CA_MOIS2=0.0, AP_CA_MOIS3=0.0, AP_CA_MOIS4=0.0, AP_CA_MOIS5=0.0, AP_CA_MOIS6=0.0, AP_CA_MOIS7=0.0, AP_CA_MOIS8=0.0, AP_CA_MOIS9=0.0, AP_CA_MOIS10=0.0, AP_CA_MOIS11=0.0, AP_CA_MOIS12=0.0, TOT_MARGE_BRUTE=0.0, MARGE_MOIS1=0.0, MARGE_MOIS2=0.0, MARGE_MOIS3=0.0, MARGE_MOIS4=0.0, MARGE_MOIS5=0.0, MARGE_MOIS6=0.0, MARGE_MOIS7=0.0, MARGE_MOIS8=0.0, MARGE_MOIS9=0.0, MARGE_MOIS10=0.0, MARGE_MOIS11=0.0, MARGE_MOIS12=0.0, MARGE_MOIS1_EU=0.0, MARGE_MOIS2_EU=0.0, MARGE_MOIS3_EU=0.0, MARGE_MOIS4_EU=0.0, MARGE_MOIS5_EU=0.0, MARGE_MOIS6_EU=0.0, MARGE_MOIS7_EU=0.0, MARGE_MOIS8_EU=0.0, MARGE_MOIS9_EU=0.0, MARGE_MOIS10_EU=0.0, MARGE_MOIS11_EU=0.0, MARGE_MOIS12_EU=0.0, AP_MARGE_MOIS1=0.0, AP_MARGE_MOIS2=0.0, AP_MARGE_MOIS3=0.0, AP_MARGE_MOIS4=0.0, AP_MARGE_MOIS5=0.0, AP_MARGE_MOIS6=0.0, AP_MARGE_MOIS7=0.0, AP_MARGE_MOIS8=0.0, AP_MARGE_MOIS9=0.0, AP_MARGE_MOIS10=0.0, AP_MARGE_MOIS11=0.0, AP_MARGE_MOIS12=0.0, AP_MARGE_MOIS1_EU=0.0, AP_MARGE_MOIS2_EU=0.0, AP_MARGE_MOIS3_EU=0.0, AP_MARGE_MOIS4_EU=0.0, AP_MARGE_MOIS5_EU=0.0, AP_MARGE_MOIS6_EU=0.0, AP_MARGE_MOIS7_EU=0.0, AP_MARGE_MOIS8_EU=0.0, AP_MARGE_MOIS9_EU=0.0, AP_MARGE_MOIS10_EU=0.0, AP_MARGE_MOIS11_EU=0.0, AP_MARGE_MOIS12_EU=0.0, NBRE_EXPEDITIONS=0, TOTAL_JOURS_AVANCE=0, MOYENNE_AVANCE=0.0, TOTAL_JOURS_RETARD=0, MOYENNE_RETARD=0.0, TOTAL_RETOURS=0, MOYENNE_RETOURS=0.0, AP_MOYENNE_AVANCE=0.0, AP_MOYENNE_RETARD=0.0, AP_MOYENNE_RETOUR=0.0, OBJECTIF_CA=0.0, OBJECTIF_CA_EU=0.0, CODE_APE=None, CA_MOIS1_EU=0.0, CA_MOIS2_EU=0.0, CA_MOIS3_EU=0.0, CA_MOIS4_EU=0.0, CA_MOIS5_EU=0.0, CA_MOIS6_EU=0.0, CA_MOIS7_EU=0.0, CA_MOIS8_EU=0.0, CA_MOIS9_EU=0.0, CA_MOIS10_EU=0.0, CA_MOIS11_EU=0.0, CA_MOIS12_EU=0.0, TOT_MARGE_BRUTE_EU=0.0, AP_CA_MOIS1_EU=0.0, AP_CA_MOIS2_EU=0.0, AP_CA_MOIS3_EU=0.0, AP_CA_MOIS4_EU=0.0, AP_CA_MOIS5_EU=0.0, AP_CA_MOIS6_EU=0.0, AP_CA_MOIS7_EU=0.0, AP_CA_MOIS8_EU=0.0, AP_CA_MOIS9_EU=0.0, AP_CA_MOIS10_EU=0.0, AP_CA_MOIS11_EU=0.0, AP_CA_MOIS12_EU=0.0, ADRESSAGE_AR='S', CAPITAL_EU=0.0, TARIF_1ER='M', TARIF_2EME='C', TARIF_3EME='P', TARIF_4EME='G', TARIF_5EME='A', ED_REMISE_VISIBLE=0, ED_NB_EXEMPLAIRE_BL=0, ED_NB_EXEMPLAIRE_FACTURE=0, UN_BL_PAR_FACTURE=0, ED_NB_EXEMPLAIRE_OFFRE=0, ED_NB_EXEMPLAIRE_AR_OFFRE=0, ED_NB_EXEMPLAIRE_AR_CMDE=0, UNE_CMDE_PAR_BL=0, ASSISTANTE=None, E_MAIL=None, SEPARER_AFFAIRES=0, CLE_ACCES=None, PRIORITE=None, TYPE_CLIENT='0000', POTENTIEL=0.0, POTENTIEL_EU=0.0, DELAI_EXPEDITION=0, MODE_PAIEMENT_TVA='D', RESP_TECHNIQUE=None, CONDITION_PAIEMENT_SAV='X1', IBAN=None, BIC=None, PLAFOND_ENCOURS_CREDIT=1000.0, PLAFOND_ENCOURS_CREDIT_EU=1000.0, LIVRAISON_PARTIELLE=1, COLLECTIF=None, ACTIF=1, DATE_CREATION='20180503', DATE_MAJ='20180504', RAISON_SOCIALE_COMPLEMENT=None, NUMERO_EORI=None, STATUT_CLIENT=None, COMMENTAIRES_STATUT=None, TYPE_ORIGINE_CLIENT=None, COMMENTAIRES_ORIGINE=None, CLIENT_FINAL=1, DISTRIBUTEUR=0, INTEGRATEUR=0, AGENT=0, CENTRE_SAV=0, GROUPE_ENTREPRISE=None, CLE='381', BANQUE_PAIEMENT=None, ZONE_LIBRE1=None, ZONE_LIBRE2=None, ZONE_LIBRE3=None, ZONE_LIBRE4=None, ZONE_LIBRE5=None, ZONE_LIBRE6=None, ZONE_LIBRE7=None, ZONE_LIBRE8=None, ZONE_LIBRE9=None, ZONE_LIBRE10=None, GROUPE=0)
	N°375 CLIENTS(CODE_CLIENT='0372', CATEGORIE='C', RAISON_SOCIALE='CONGO SURVEILLANCE', TELEPHONE=None, TELEX=None, FAX=None, SITE_WEB=None, NOM_RUE_SIEGE="14 Avenue de l'Equateur\r\nQ Centre ville C/Gombe", LOCALITE_SIEGE='GOMBE', CODE_POSTAL_SIEGE=None, PAYS_SIEGE='RDC', INTERLOCUTEUR_SIEGE=None, TELEPHONE_DIRECT=None, ADRESSE_AR_COMMANDE=None, ADRESSE_LIVRAISON=None, ADRESSE_FACTURATION=None, LANGUE='F', DEVISE='EUR', CONDITION_PAIEMENT='V1', MODE_TRANSPORT='02', FRANCHISE_PORT=0.0, FORME_JURIDIQUE=None, CAPITAL=0.0, EFFECTIFS=0.0, RC=None, INTRACOM=None, SIRET=None, BANQUE=None, ETABLISSEMENT=None, GUICHET=None, COMPTE=None, CLE_RIB=None, COMPTE_CLIENT=None, COMMERCIAL='0007', ZONE_GEOGRAPHIQUE='ZZZZ', REMISE_PARTICULIERE=0.0, COMMENTAIRES=None, ESCOMPTE=0.0, PLAFOND_ENCOURS=1000.0, PLAFOND_ENCOURS_EU=1000.0, CLIENT_LITIGIEUX=0, ACTIVITE='ZZZZ', TRANSPORTEUR='ZZZZ', LOCALISATION='F', MODE_CALCUL_TVA='N', NUMERO_FOURNISSEUR=None, HT_OFFRES=0.0, HT_OFFRES_EU=0.0, DATE_DERN_OFFRE=None, NBRE_OFFRES=0, AP_NBRE_OFFRES=0, NBRE_OFFRES_CDES=0, AP_NBRE_OFFRES_CDES=0, ENCOURS_CDES=229.09, ENCOURS_CDES_EU=229.09, CA_AN=0.0, CA_AN_EU=0.0, AP_CA_AN=0.0, AP_CA_AN_EU=0.0, DATE_DERN_CDE='20180504', CA_MOIS1=0.0, CA_MOIS2=0.0, CA_MOIS3=0.0, CA_MOIS4=0.0, CA_MOIS5=0.0, CA_MOIS6=0.0, CA_MOIS7=0.0, CA_MOIS8=0.0, CA_MOIS9=0.0, CA_MOIS10=0.0, CA_MOIS11=0.0, CA_MOIS12=0.0, AP_CA_MOIS1=0.0, AP_CA_MOIS2=0.0, AP_CA_MOIS3=0.0, AP_CA_MOIS4=0.0, AP_CA_MOIS5=0.0, AP_CA_MOIS6=0.0, AP_CA_MOIS7=0.0, AP_CA_MOIS8=0.0, AP_CA_MOIS9=0.0, AP_CA_MOIS10=0.0, AP_CA_MOIS11=0.0, AP_CA_MOIS12=0.0, TOT_MARGE_BRUTE=0.0, MARGE_MOIS1=0.0, MARGE_MOIS2=0.0, MARGE_MOIS3=0.0, MARGE_MOIS4=0.0, MARGE_MOIS5=0.0, MARGE_MOIS6=0.0, MARGE_MOIS7=0.0, MARGE_MOIS8=0.0, MARGE_MOIS9=0.0, MARGE_MOIS10=0.0, MARGE_MOIS11=0.0, MARGE_MOIS12=0.0, MARGE_MOIS1_EU=0.0, MARGE_MOIS2_EU=0.0, MARGE_MOIS3_EU=0.0, MARGE_MOIS4_EU=0.0, MARGE_MOIS5_EU=0.0, MARGE_MOIS6_EU=0.0, MARGE_MOIS7_EU=0.0, MARGE_MOIS8_EU=0.0, MARGE_MOIS9_EU=0.0, MARGE_MOIS10_EU=0.0, MARGE_MOIS11_EU=0.0, MARGE_MOIS12_EU=0.0, AP_MARGE_MOIS1=0.0, AP_MARGE_MOIS2=0.0, AP_MARGE_MOIS3=0.0, AP_MARGE_MOIS4=0.0, AP_MARGE_MOIS5=0.0, AP_MARGE_MOIS6=0.0, AP_MARGE_MOIS7=0.0, AP_MARGE_MOIS8=0.0, AP_MARGE_MOIS9=0.0, AP_MARGE_MOIS10=0.0, AP_MARGE_MOIS11=0.0, AP_MARGE_MOIS12=0.0, AP_MARGE_MOIS1_EU=0.0, AP_MARGE_MOIS2_EU=0.0, AP_MARGE_MOIS3_EU=0.0, AP_MARGE_MOIS4_EU=0.0, AP_MARGE_MOIS5_EU=0.0, AP_MARGE_MOIS6_EU=0.0, AP_MARGE_MOIS7_EU=0.0, AP_MARGE_MOIS8_EU=0.0, AP_MARGE_MOIS9_EU=0.0, AP_MARGE_MOIS10_EU=0.0, AP_MARGE_MOIS11_EU=0.0, AP_MARGE_MOIS12_EU=0.0, NBRE_EXPEDITIONS=0, TOTAL_JOURS_AVANCE=0, MOYENNE_AVANCE=0.0, TOTAL_JOURS_RETARD=0, MOYENNE_RETARD=0.0, TOTAL_RETOURS=0, MOYENNE_RETOURS=0.0, AP_MOYENNE_AVANCE=0.0, AP_MOYENNE_RETARD=0.0, AP_MOYENNE_RETOUR=0.0, OBJECTIF_CA=0.0, OBJECTIF_CA_EU=0.0, CODE_APE=None, CA_MOIS1_EU=0.0, CA_MOIS2_EU=0.0, CA_MOIS3_EU=0.0, CA_MOIS4_EU=0.0, CA_MOIS5_EU=0.0, CA_MOIS6_EU=0.0, CA_MOIS7_EU=0.0, CA_MOIS8_EU=0.0, CA_MOIS9_EU=0.0, CA_MOIS10_EU=0.0, CA_MOIS11_EU=0.0, CA_MOIS12_EU=0.0, TOT_MARGE_BRUTE_EU=0.0, AP_CA_MOIS1_EU=0.0, AP_CA_MOIS2_EU=0.0, AP_CA_MOIS3_EU=0.0, AP_CA_MOIS4_EU=0.0, AP_CA_MOIS5_EU=0.0, AP_CA_MOIS6_EU=0.0, AP_CA_MOIS7_EU=0.0, AP_CA_MOIS8_EU=0.0, AP_CA_MOIS9_EU=0.0, AP_CA_MOIS10_EU=0.0, AP_CA_MOIS11_EU=0.0, AP_CA_MOIS12_EU=0.0, ADRESSAGE_AR='S', CAPITAL_EU=0.0, TARIF_1ER='M', TARIF_2EME='C', TARIF_3EME='P', TARIF_4EME='G', TARIF_5EME='A', ED_REMISE_VISIBLE=0, ED_NB_EXEMPLAIRE_BL=0, ED_NB_EXEMPLAIRE_FACTURE=0, UN_BL_PAR_FACTURE=0, ED_NB_EXEMPLAIRE_OFFRE=0, ED_NB_EXEMPLAIRE_AR_OFFRE=0, ED_NB_EXEMPLAIRE_AR_CMDE=0, UNE_CMDE_PAR_BL=0, ASSISTANTE=None, E_MAIL=None, SEPARER_AFFAIRES=0, CLE_ACCES=None, PRIORITE=None, TYPE_CLIENT='0000', POTENTIEL=0.0, POTENTIEL_EU=0.0, DELAI_EXPEDITION=0, MODE_PAIEMENT_TVA='D', RESP_TECHNIQUE=None, CONDITION_PAIEMENT_SAV='V1', IBAN=None, BIC=None, PLAFOND_ENCOURS_CREDIT=1000.0, PLAFOND_ENCOURS_CREDIT_EU=1000.0, LIVRAISON_PARTIELLE=1, COLLECTIF=None, ACTIF=1, DATE_CREATION='20180504', DATE_MAJ='20180504', RAISON_SOCIALE_COMPLEMENT=None, NUMERO_EORI=None, STATUT_CLIENT=None, COMMENTAIRES_STATUT=None, TYPE_ORIGINE_CLIENT=None, COMMENTAIRES_ORIGINE=None, CLIENT_FINAL=1, DISTRIBUTEUR=0, INTEGRATEUR=0, AGENT=0, CENTRE_SAV=0, GROUPE_ENTREPRISE=None, CLE='382', BANQUE_PAIEMENT=None, ZONE_LIBRE1=None, ZONE_LIBRE2=None, ZONE_LIBRE3=None, ZONE_LIBRE4=None, ZONE_LIBRE5=None, ZONE_LIBRE6=None, ZONE_LIBRE7=None, ZONE_LIBRE8=None, ZONE_LIBRE9=None, ZONE_LIBRE10=None, GROUPE=0)


Lecture des fournisseurs
-------------------------


::

    pipenv run python test_read_dbgpao.py test_read_fournisseurs


::

    ...
	N°631 FOURNISSEURS(CODE_FOURNISSEUR='0629', RAISON_SOCIALE='SAPRATIN TECHNOLOGIES', SITE_WEB='www.sapratin.com', ACTIF=1, DATE_CREATION='20170921', DATE_MAJ='20180201')
	N°632 FOURNISSEURS(CODE_FOURNISSEUR='0630', RAISON_SOCIALE='JPC', SITE_WEB='www.jpcfrance.fr', ACTIF=1, DATE_CREATION='20171006', DATE_MAJ='20180201')
	N°633 FOURNISSEURS(CODE_FOURNISSEUR='0631', RAISON_SOCIALE='ASTON Technologies', SITE_WEB='www.astonic-france.com', ACTIF=1, DATE_CREATION='20171123', DATE_MAJ='20180216')
	N°634 FOURNISSEURS(CODE_FOURNISSEUR='0633', RAISON_SOCIALE='ALPWISE', SITE_WEB=None, ACTIF=1, DATE_CREATION='20171211', DATE_MAJ='20180228')
	N°635 FOURNISSEURS(CODE_FOURNISSEUR='0634', RAISON_SOCIALE='CIPSACIRCUITS', SITE_WEB=None, ACTIF=1, DATE_CREATION='20171219', DATE_MAJ='20180216')
	N°636 FOURNISSEURS(CODE_FOURNISSEUR='0635', RAISON_SOCIALE='SHUTTERSTOCK', SITE_WEB=None, ACTIF=1, DATE_CREATION='20180216', DATE_MAJ='20180328')
	N°637 FOURNISSEURS(CODE_FOURNISSEUR='0636', RAISON_SOCIALE='IDS Imaging Development Sysyems', SITE_WEB=None, ACTIF=1, DATE_CREATION='20180404', DATE_MAJ='20180531')
	N°638 FOURNISSEURS(CODE_FOURNISSEUR='0637', RAISON_SOCIALE='EET EUROPARTS', SITE_WEB=None, ACTIF=1, DATE_CREATION='20180524', DATE_MAJ=None)
	N°639 FOURNISSEURS(CODE_FOURNISSEUR='0638', RAISON_SOCIALE='MATERIEL ELECTRIQUE.COM', SITE_WEB='www,materielelectrique.com', ACTIF=1, DATE_CREATION='20180525', DATE_MAJ='20180525')
